This lab is a forked lab from many found on @, starting from Microsoft one : https://github.com/Azure/SONiC/wiki/SONiC-P4-Software-Switch

The diagram of the architecture is into the zip file (SONIC_LAB.jpg)

To run the lab you need : 

- to have installed docker by using ./install_docker_ovs.sh
- to run the ./load_image.sh in order to get the Sonic image

Note : don't change file / folders names of network devices (leafX, spineX)

Once you're ready, please run the lab by launching ./start

The script :

	- launches the containers without Docket network features
	- create network namespaces
	- build linux bridges to interconnect the containers
	- configure host IPs
	- launch startup sonic scripts into sonic devices
	- once devices started, checks + ping tests are run. If all BGP sessions are ok on spine + all ping are fine, the setup works well.

Below some useful commands to run for sonic containers : 

# run ping

sudo docker exec -it <container> ping <ip>

plancastre@dockerhost:~/00.Projects/p4-version-pla$ sudo docker exec -it leaf1 ping 192.168.1.1
[sudo] Mot de passe de plancastre : 
PING 192.168.1.1 (192.168.1.1): 56 data bytes
64 bytes from 192.168.1.1: icmp_seq=0 ttl=64 time=0.052 ms
64 bytes from 192.168.1.1: icmp_seq=1 ttl=64 time=0.034 ms
^C--- 192.168.1.1 ping statistics ---

# check bgp sessions

sudo docker exec -it <container> vtysh -c "show ip bgp sum"

plancastre@dockerhost:~/00.Projects/p4-version-pla$ sudo docker exec -it spine1 vtysh -c "show ip bgp sum"
BGP router identifier 10.1.0.1, local AS number 65001
RIB entries 8, using 896 bytes of memory
Peers 4, using 18 KiB of memory

Neighbor        V         AS MsgRcvd MsgSent   TblVer  InQ OutQ Up/Down  State/PfxRcd
10.1.0.0        4 65101    6409    6411        0    0    0 01:46:46        3
10.1.0.2        4 65102    6406    6410        0    0    0 01:46:44        3
10.1.0.4        4 65103    6407    6410        0    0    0 01:46:44        4
10.1.0.6        4 65104    6406    6412        0    0    0 01:46:46        1

Total number of neighbors 4

# check ip route

sudo docker exec -it <container> vtysh -c "show ip route"

plancastre@dockerhost:~/00.Projects/p4-version-pla$ sudo docker exec -it spine1 vtysh -c "show ip route"
Codes: K - kernel route, C - connected, S - static, R - RIP,
       O - OSPF, I - IS-IS, B - BGP, P - PIM, A - Babel,
       > - selected route, * - FIB route

C>* 10.1.0.0/31 is directly connected, Vlan11
C>* 10.1.0.2/31 is directly connected, Vlan21
C>* 10.1.0.4/31 is directly connected, Vlan31
C>* 10.1.0.6/31 is directly connected, Vlan41
C>* 127.0.0.0/8 is directly connected, lo
B>* 192.168.1.0/24 [20/0] via 10.1.0.0, Vlan11, 01:47:23
B>* 192.168.2.0/24 [20/0] via 10.1.0.2, Vlan21, 01:47:21
B>* 192.168.3.0/24 [20/0] via 10.1.0.4, Vlan31, 01:47:21
B>* 192.168.4.0/24 [20/0] via 10.1.0.6, Vlan41, 01:47:23


For more commands check SONiC docs : https://github.com/Azure/sonic-utilities/blob/master/doc/Command-Reference.md#arp-show-commands
